// getmwinstall.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "getmwinstall.h"

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}


// This is an example of an exported variable
GETMWINSTALL_API int nGetmwinstall=0;

// This is an example of an exported function.
GETMWINSTALL_API int fnGetmwinstall(void)
{
	return 42;
}

// This is the constructor of a class that has been exported.
// see getmwinstall.h for the class definition
CGetmwinstall::CGetmwinstall()
{ 
	return; 
}

JNIEXPORT jstring JNICALL Java_reorderPlugins_getMWInstallPath(JNIEnv *env, jobject self)
{
	HKEY key;
	LONG retCode = RegOpenKeyEx(HKEY_LOCAL_MACHINE,
								"Software\\Bethesda Softworks\\Morrowind",
                                //"Software\\Bethesda Softworks\\Morrowind\\Installed Path",
                                0,
	                            KEY_READ,
	                            &key);
	if (retCode != ERROR_SUCCESS)
		return 0;


	BYTE buffer[2048];
	DWORD bufsize = 2048;
	retCode = RegQueryValueEx(key,
	                          "Installed Path",
	                          0,
	                          0,
	                          &buffer[0],
	                          &bufsize);
	RegCloseKey(key);
	if (retCode != ERROR_SUCCESS)
	{
		return 0;
	}
	
	return env->NewStringUTF(reinterpret_cast<const char *>(&buffer[0]));
}
